package Flash;

use strict;
use Carp;
use vars qw($VERSION @ISA @EXPORT @EXPORT_OK $AUTOLOAD);

require Exporter;
require DynaLoader;
require AutoLoader;


@ISA = qw(Exporter DynaLoader);
# Items to export into callers namespace by default. Note: do not export
# names by default without a very good reason. Use EXPORT_OK instead.
# Do not simply export all your public functions/methods/constants.
@EXPORT = qw(
	FlashBSDown
	FlashBSHitTest
	FlashBSOver
	FlashBSUp
	FlashButtonEnter
	FlashButtonExit
	FlashIdletoOverDown
	FlashIdletoOverUp
	FlashMenuEnter
	FlashMenuExit
	FlashModColour
	FlashModMatrix
	FlashOutDowntoIdle
	FlashOutDowntoOverDown
	FlashOverDowntoIdle
	FlashOverDowntoOutDown
	FlashOverDowntoOverUp
	FlashOverUptoIdle
	FlashOverUptoOverDown
	FlashTypeMenuButton
	FlashTypePushButton
  openswf
  closeswf
  nextid
  label_frame
  show_frame
  set_frame
  get_frame
  add_colour
  mul_colour
  place_object
  modify_object
  remove_object
  line
  rect
  start_symbol
  end_symbol
  ortho2
  start_doaction
  end_doaction
  action_play
  action_stop
  start_button
  add_buttonrecord
  on_condition
  action_goto_frame
  action_get_URL
  action_next_frame
  action_prev_frame
  action_toggle_quality
  action_stop_sounds
  action_wait_for_frame
  action_set_target
  action_goto_label
  end_button
  push_matrix
  pop_matrix
  viewport
  scale
  translate
  rotate
  ortho
  polarview
  lookat
  perspective
  pos_round
  font_size
  font_slant
  font_tracking
  font_line_width
  define_font
  set_font
  text_width
  get_font_info
  define_text
  define_bitmap
  get_bitmap_info
  start_shape
  shape_line_solid
  shape_fill_off
  shape_fill_solid
  shape_fill_bitmap_clip
  shape_fill_bitmap_tile
  shape_moveto
  shape_lineto
  shape_curveto
  shape_curveto3
  shape_arc
  end_shape
  sound_rate
  sound_compression
  define_sound
  define_button_sound
  sound_stream
  start_sound
  make_rect
  rect_image
);

$VERSION = '0.007';

my $_ID       = 1;
my $_tempfile = 0;
my $_filename;

sub nextid
{
        return $_ID++;
}

sub openswf
{
        $_filename = shift;
        my ($xsize,$ysize,$framerate,$r,$g,$b) = @_;

        $framerate |= 1;
        $r |= 1;
        $g |= 1;
        $b |= 1;

        if ($_filename eq '-'){
                $_filename = time(). {}. rand(). $$;
                $_tempfile = 1;
           
        }

        print STDERR "Fname is $_filename\n";
        doopenswf("$_filename",$xsize,$ysize,$framerate,$r,$g,$b);

}

sub closeswf {

        print STDERR "attempting to close SWF file\n"; 
        docloseswf();

        print STDERR "Closed swf file\n";
        if (1)
        {
                print STDERR "printing SWF\n";
                open IN, "$_filename";
                while (<IN>) { print; }
                close IN;
                
                print STDERR "Unlinking $_filename\n";
                unlink $_filename;
                $_tempfile = 0;
        }
}




sub DESTROY
{
        docloseswf();
        unlink $_filename if ($_tempfile);
}

sub AUTOLOAD {
    # This AUTOLOAD is used to 'autoload' constants from the constant()
    # XS function.  If a constant is not found then control is passed
    # to the AUTOLOAD in AutoLoader.

    my $constname;
    ($constname = $AUTOLOAD) =~ s/.*:://;
    my $val = constant($constname, @_ ? $_[0] : 0);
    if ($! != 0) {
	if ($! =~ /Invalid/) {
	    $AutoLoader::AUTOLOAD = $AUTOLOAD;
	    goto &AutoLoader::AUTOLOAD;
	}
	else {
		croak "Your vendor has not defined Flash macro $constname";
	}
    }
    eval "sub $AUTOLOAD { $val }";
    goto &$AUTOLOAD;
}

bootstrap Flash $VERSION;

# Preloaded methods go here.

# Autoload methods go after =cut, and are processed by the autosplit program.

sub make_rect
{
    my ($x1, $y1, $x2, $y2) = @_;

    Flash::shape_moveto($x1,$y1);
    Flash::shape_lineto($x2,$y1);
    Flash::shape_lineto($x2,$y2);
    Flash::shape_lineto($x1,$y2);
    Flash::shape_lineto($x1,$y1);
}


sub rect_image
{
        my ($bitmapid, $rectid) = @_;

        $rectid = Flash::nextid() unless (defined $rectid);
        my ($xsize, $ysize) = Flash::get_bitmap_info($bitmapid);
	      Flash::start_shape($rectid);
          Flash::shape_line_solid(0.0,0.0,0.0,1.0,0.1);
          Flash::shape_fill_bitmap_clip($bitmapid);
          Flash::make_rect(-$xsize/2,-$ysize/2,$xsize/2.0,$ysize/2,20);
        Flash::end_shape();
        return $rectid;

}

1;
__END__
# Below is the stub of documentation for your module. You better edit it!

=head1 NAME

Flash - Perl extension for Flash libswf.a

=head1 SYNOPSIS

  use Flash;

=head1 DESCRIPTION

Flash is a gives you PERL access to libswf.a as programmed by Paul Haeberli.
To obtain the library go to http://reality.sgi.com/grafica/flash/

This has now been modifed by me for my own nefarious uses but
it is based on code by The Labs (http://the-labs.com/FlashPerl/).

It is part of a suite of SWF manipulation modules, Flash::*, for the
analysis, creation, decomposition and general hacking of Shockwave Flash
movies, by Simon Wistow

=head1 File management functions

=over 4

=item openswf (FILENAME, WIDTH, HEIGHT , FRAMERATE, R=1, G=1, B=1)

Start a new SWF file. the rgb values, which must be between 0 and 1 will set the background colour. They default to 1.

=item closeswf ()

Outputs the SWF file.

=back


=head1 Managing the Contents of the Current Frame

=over 4

=item label_frame (LABEL)

Used to label the frame (surprisingly) so that action_goto_label can jump to it. Good place for secret messages :)

=item show_frame

Shows the current frame and starts a new one.

=item set_frame

Selects the frame you should add commands to.

=item get_frame

returns the frame you are currently working on.

=back

=head1 Setting the Current Color

=over 4

=item add_colour(R=0, G=0, B=0, A=0)

Sets the global add colour to the rgba value specified. This colour is used by place_object, modify_object and add_button_record.
This colour is added to the original colour of the object when it is drawn. These values can be positive or negative.

=item mul_colour(R=1, G=1, B=1, A=1)

Sets the global multiply colour to the rgba value specified. This colour is used by place_object, modify_object and add_button_record.
The colour of the object will be multiplied by the values given when it is drawn. These values can be positive or negative.

=back

=head1 Geometry Functions

=over 4

=item viewport(XMIN, XMAX, YMIN, YMAX)

Selects an area on the drawing surface for future drawing. This defaults to the screen area of the Flash movie.

=item  ortho(XMIN=-100, XMAX=100, YMIN=-100, YMAX=100,ZMIN=-100,ZMAX=100)
=item ortho2(XMIN=-100, XMAX=100, YMIN=-100, YMAX=100)

Defines a 2D orthographic mapping of user coordinates onto the current viewport. This defaults to be a one to one mapping with the area of the Flash movie. If a perspective transformation is desired, swf_perspective may be used.

=item perspective(FOVY, ASPECT, NEAR, FAR)

Define a perspective projection transformation. Fovy selects the field-of-view angle in the y direction. Aspect should be set to the aspect ratio of the viewport we're drawing into. The near and far clipping planes are specified by near and far. Various distortion artifacts may appear when using a perspective projection, since Flash players only have a 2D matrix. Some of these can be quite disturbing.

=item polarview(DIST, AZIMUTH, INCIDENCE, TWIST)

Defines the viewer's position in polar coordinates. dist selects the distance from the viewpoint to the world space origin. Azimuth defines the azimuthal angle in the x-y plane, measured from the y axis. Incidence specifies the angle of incidence in the y-z plane, measured from the z axis. The incidence angle is the angle of the viewport relative to the z axis. Twist defines the amount that the viewpoint is to be rotated around the line of sight using the right-hand rule.

=item lookat(VX, VY, VZ, PX, PY, PZ, TWIST)

Defines a viewing transformation by giving the view position vx, vy, vz, and the coordinates of a reference point in the scene at px, py, pz. Twist controls a rotation along the viewer's z axis.

=item push_matrix ()

Push the current transformation matrix onto the stack.

=item pop_matrix ()

Restore a previous transformation matrix.

=item scale(X, Y, Y)

Scale the current transformation.

=item translate(X, Y, Z)

Translate the current transformation.

=item rotate(ANGLE, AXIS)

Rotate the current transformation by the given angle about x, y, or z axis. The axis may be 'x', 'y', or 'z'.

=item pos_round(SET)

This enables or disables rounding of the translation when objects are places or moved. There are times when text can be made more readable if position rounding is turned on.

=back

=head1 Placing and Removing Objects

=over 4

=item place_object(ID, DEPTH)

Places the object with the ID specified to be placed at the specified depth.
There is a maximum on both those figures of 65535 and they both must be more than 1.

=item modify_object(DEPTH, HOW)

Modify the objects at the given depth.
HOW can either be FlashModColour, FlashModMatrix or FlashModColour|FlashModMatrix.

=item remove_object(DEPTH)

Remove the objects at the given depth

=item nextid ()

Return the next free Id.

=back

=head1 Defining Buttons

Buttons provide the interaction in Flash movies. The functions below are used to define the appearance
and behavior of a button. In typical application, a complete button will look something like this:

  start_button(objid,TYPE_MENUBUTTON);
    add_buttonrecord(FlashBSHitTest|FlashBSDown|FlashBSOver|FlashBSUp,RECTFILLID,3000);
      on_condition(FlashMenuEnter);
          swf_actionGetURL("overlay.swf","_level1");
      on_condition(FlashMenuExit);
          swf_actionGetURL("","_level1");
  end_button();



A button definition always starts with start_button and ends with end_button. There should be one or
more add_buttonrecord calls, and zero or more calls to on_condition followed by action elements.
To make a button appear on the screen, you will have to use place_object to position it in a frame.



=over 4

=item start_button ()

Starts the definition of a button with the specified object id. type can have the value TYPE_MENUBUTTON
or TYPE_PUSHBUTTON. this will select whether focus can move from the button while the mouse is down.
If type is TYPE_MENUBUTTON, focus travels, while if type is TYPE_PUSHBUTTON, focus stays with the button.

=item add_buttonrecord (STATE, ID, DEPTH)

Controls the location, appearance and active area of the current button. There must be one or more calls
to this function to indicate what object to associate with FlashBSHitTest (the button hit test area) and
BSUp, BSOver and BSDown (the three button state bits). This uses the current mulcolor, addcolor and matrix
to position and color the specified object. There can be any number of button records in a single button.

=item on_condition (CONDITION)

Describes a transition used to trigger an action list.

=back

These transitions apply to buttons of type TYPE_MENUBUTTON:

  FlashIdletoOverUp
  FlashOverUptoIdle
  FlashOverUptoOverDown
  FlashOverDowntoOverUp

  FlashIdletoOverDown
  FlashOutDowntoIdle

  FlashMenuEnter = (FlashIdletoOverUp|FlashIdletoOverDown)
  FlashMenuExit  = (FlashOverUptoIdle|FlashOverDowntoIdle)

  These transitions apply to buttons of type TYPE_PUSHBUTTON:

  FlashIdletoOverUp
  FlashOverUptoIdle
  FlashOverUptoOverDown
  FlashOverDowntoOverUp

  FlashOverDowntoOutDown
  FlashOutDowntoOverDown
  FlashOutDowntoIdle

  FlashButtonEnter = (FlashIdletoOverUp|FlashOutDowntoOverDown)
  FlashButtonExit  = (FlashOverUptoIdle|FlashOverDowntoOutDown)

The call to swf_oncondition should be followed by one or more action elements as described above.

= over 4

=item end_button ()

Completes the definition of a button.

=back

=head1 Defining Symbols

=over 4

=item start_symbol

Symbols are tiny Flash movies that can be played simultaneously. To define a symbol, call this function with the objid that you want to use to identify the symbol.

=item end_symbol

Completes the symbol.

=back

=head1 Action Control

An action list is described by a sequence of calls as shown here:


   start_doaction();
      action_goto_frame(143);
      action_play();
    end_doaction();

You can put lots and lots of actions between startDoAction and endDoAction to create an actionlist. All the actions are performed in sequence after the current frame is drawn.

=over 4

=item start_doaction()

This starts the description of an action list for the current frame. There should be only one action list associated with a single frame in the Flash movie.

=item end_doaction()

Ends the list of actions to perform for the current frame.

=item action_play()

Starts playing the Flash movie from the current frame.

=item action_stop()

Stops playing the Flash movie at the current frame.

=item action_goto_frame(FRAME)

Causes the Flash movie to display the specified frame and stop.

=item action_get_URL(URL,TARGET)

Gets the specified URL. TARGET indicates what to do with the content from the URL. If target is "_level0", data from the URL will replace the current Flash movie. If target is "_level1", The new URL will displayed on top of the current Flash movie.

=item action_next_frame()

Goes forward one frame.

=item action_prev_frame()

Goes backward one frame.

=item action_toggle_quality()

Toggles between high and low quality.

=item action_stop_sounds()

Stops playing sound.

=item action_wait_for_frame(FRAME, SKIPCOUNT)

If the specified frame has not been loaded, skip the specified number of actions in the action list. This can be used to show an animation while frames are being loaded.

=item action_set_target(TARGET)

Set the context for actions. This can be used to control other Flash movies that are playing.

=item action_goto_label(LABEL)

Causes the Flash movie to display the frame with the given label, and stop.

=back

=head1 Defining Fonts and Text

=over 4

=item define_font(FONTID, NAME)

Defines a font name specifies the PostScript name of the font to use. This font also becomes the current font.

=item set_font(FONTID)

Sets the current font to the font indicated by fontid.

=item font_size (HEIGHT=10)

Sets the current font size to the height indicated.

=item font_slant(SLANT)

Sets the current font slant to the slant angle indicated. Positive values slant forward, negative values slant backwards.

=item font_tracking(TRACK)

Sets the current font tracking to the specified value. The is used to adjust the spacing between letters in text.  Positive values increase the amount of space, while negative numbers decrease the amount of space. A tracking value of 1.0 will add the currenet font height's worth of space between letters.

=item get_font_info()

Returns the height of a capital 'A' and a lowercase 'x' in the current font;

=item font_line_width (WIDTH)

Sets the width of the font outlines.

=item text_width(TEXT)

Returns the width of the text using the current font settings.

=item define_text(TEXT, DOCENTER=0)

Define some text using the current font values. setting DOCENTER to 1 will center the text in the x axis.

=back

=head1 Bitmap functions

=over 4

=item define_bitmap ()

Defines a bitmap given the name of a .gif .rgb .jpeg or .fi image. The image will be converted into Flash jpeg or Flash color map format.

=item get_bitmap_info ()

Returns the size of a previously defined bitmap. xsize and ysize are the width and height in pixels.

=back

=head1 Defining Shapes

=head2 Simple shapes

=over 4

=item line (ID, X1, Y1, X2, Y2, WIDTH=1)

Defines a line segment from x1,y1 to x2,y2 with the given line width.

=item rect (ID, X1, Y1, X2, Y2, WIDTH=1)

Defines an outlined rectangle from x1,y1 to x2,y2 with the given line width. If width is 0.0, the rectangle is filled instead of stroked.

=back

=head2 Complex Shapes

=over 4

=item start_shape (ID)

Starts the definition of a complex shape. An object with the specified objid will be created.

=item shape_line_solid(R, G, B, A, WIDTH)

Sets the current line style. The color is given by r, g, b, and a. width specifies the thickness of the line. If a width of 0.0 is given, no lines are drawn.

=item shape_fill_off ()

Turns off filling.

=item shape_fill_solid (BITMAPID)

Sets the current fill style to a solid fill with the the specified color.

=item shape_fill_bitmap_clip (BITMAPID)

Sets the current fill mode clipped bitmap fill. Pixels from the previously defined bitmapid will be used to fill areas.

=item shape_fill_bitmap_tile

Sets the current fill mode tiled bitmap fill. Pixels from the previously defined bitmapid will be used to fill areas. The image will repeat across the area.

=item shape_moveto (X,Y)

This moves the current position to the given x,y.

=item shape_lineto (X,Y)

Draws a line from the current position to x,y. Then the current position is set to x,y.

=item shape_curveto (X1,Y1, X2, Y2)

Draws a quadradic bezier curve starting at the current position using x1,y1 as an off curve control point and using x2,y2 as the end point. Then the current position is set to x2,y2.

=item shape_curveto3 (X1,Y1, X2, Y2, X3, Y3)

Draws a cubic bezier curve starting at the current position using x1,y1 and x2,y2 as off curve control points and using x3,y3 as the end point. Then the current position is set to x3,y3. The cubic bezier curve is converted to the quadradic beziers used internally by Flash.

=item shape_arc (X, Y, R, ANGLE1, ANGLE2)

Draws a circular arc from ang1 to ang2. The center of the circle is given by x, and y. r specifies the radius of the arc.

=item end_shape ()

Completes the definition of the current shape.

=back

=head1 Defining Sounds

=over 4

=item sound_rate(RATE=22000)

Sets the sample rate for future sound definitions to the specified value. The only rates supported are 5500, 11000, 22000 and 44000 sampels pre second.

=item sound_compression(BITS=2)

Selects the number of bits that sound samples should be compressed to when sounds are defined. The only values supported are 0, 2, 3, 4 and 5. The value of 0 is used to create sounds with no compression. NB: It looks like the Flash plugin on some PC's have trouble playing uncompressed sound.

=item define_sound(ID, FILE)

Defines a sound.

=item define_button_sound(OBJID, OUTID, OVERID, DOWNID)

Associates sounds with an already defined button. outid, overid and downid can be previously defined sounds, or 0 if no sound should be playd for the particular transition.


=item sound_stream(FILE)

Adds the samples to the movie starting at the current frame. The number of frames that the sound plays for is returned.

=item start_sound ()

Starts playing the sound defined by soundid.

=back

=head1 AUTHOR

Simon Wistow <simon@twoshortplanks.com> based on code
orginally by Rene K. Mueller <kiwi@the-labs.com>

=head1 SEE ALSO

perl(1), Flash::Object

=cut
