#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "swf.h"
#include <audiofile.h>
#include <stdio.h>

/*
   Copyright 2000, Simon Wistow (simon@twoshortplanks.com)
   based on code by  Rene K. Mueller <kiwi@the-labs.com>
   see README for usage restrictions (GPL)
 */

/* button types */

#define FlashTypePushButton		(0)
#define FlashTypeMenuButton		(1)

/* button shape states */

#define FlashBSHitTest       	(0x8)
#define FlashBSDown          	(0x4)
#define FlashBSOver          	(0x2)
#define FlashBSUp            	(0x1)

/* button transitions */

#define FlashOverDowntoIdle          (256)
#define FlashIdletoOverDown          (128)
#define FlashOutDowntoIdle            (64)
#define FlashOutDowntoOverDown        (32)
#define FlashOverDowntoOutDown        (16)
#define FlashOverDowntoOverUp          (8)
#define FlashOverUptoOverDown          (4)
#define FlashOverUptoIdle              (2)
#define FlashIdletoOverUp              (1)

#define FlashButtonEnter          	(FlashIdletoOverUp|FlashOutDowntoOverDown)
#define FlashButtonExit             (FlashOverUptoIdle|FlashOverDowntoOutDown)

#define FlashMenuEnter              (FlashIdletoOverUp|FlashIdletoOverDown)
#define FlashMenuExit               (FlashOverUptoIdle|FlashOverDowntoIdle)

/* for modifyobject how */

#define FlashModMatrix	(1)
#define FlashModColor	(2)


static int
not_here(s)
char *s;
{
    croak("%s not implemented on this architecture", s);
    return -1;
}

static double
constant(name, arg)
char *name;
int arg;
{
    errno = 0;
    switch (*name) {
    case 'A':
	break;
    case 'B':
	break;
    case 'C':
	break;
    case 'D':
	break;
    case 'E':
	break;
    case 'F':
	if (strEQ(name, "FlashBSDown"))
#ifdef FlashBSDown
	    return FlashBSDown;
#else
	    goto not_there;
#endif
	if (strEQ(name, "FlashBSHitTest"))
#ifdef FlashBSHitTest
	    return FlashBSHitTest;
#else
	    goto not_there;
#endif
	if (strEQ(name, "FlashBSOver"))
#ifdef FlashBSOver
	    return FlashBSOver;
#else
	    goto not_there;
#endif
	if (strEQ(name, "FlashBSUp"))
#ifdef FlashBSUp
	    return FlashBSUp;
#else
	    goto not_there;
#endif
	if (strEQ(name, "FlashButtonEnter"))
#ifdef FlashButtonEnter
	    return FlashButtonEnter;
#else
	    goto not_there;
#endif
	if (strEQ(name, "FlashButtonExit"))
#ifdef FlashButtonExit
	    return FlashButtonExit;
#else
	    goto not_there;
#endif
	if (strEQ(name, "FlashIdletoOverDown"))
#ifdef FlashIdletoOverDown
	    return FlashIdletoOverDown;
#else
	    goto not_there;
#endif
	if (strEQ(name, "FlashIdletoOverUp"))
#ifdef FlashIdletoOverUp
	    return FlashIdletoOverUp;
#else
	    goto not_there;
#endif
	if (strEQ(name, "FlashMenuEnter"))
#ifdef FlashMenuEnter
	    return FlashMenuEnter;
#else
	    goto not_there;
#endif
	if (strEQ(name, "FlashMenuExit"))
#ifdef FlashMenuExit
	    return FlashMenuExit;
#else
	    goto not_there;
#endif
	if (strEQ(name, "FlashModColor"))
#ifdef FlashModColor
	    return FlashModColor;
#else
	    goto not_there;
#endif
	if (strEQ(name, "FlashModMatrix"))
#ifdef FlashModMatrix
	    return FlashModMatrix;
#else
	    goto not_there;
#endif
	if (strEQ(name, "FlashOutDowntoIdle"))
#ifdef FlashOutDowntoIdle
	    return FlashOutDowntoIdle;
#else
	    goto not_there;
#endif
	if (strEQ(name, "FlashOutDowntoOverDown"))
#ifdef FlashOutDowntoOverDown
	    return FlashOutDowntoOverDown;
#else
	    goto not_there;
#endif
	if (strEQ(name, "FlashOverDowntoIdle"))
#ifdef FlashOverDowntoIdle
	    return FlashOverDowntoIdle;
#else
	    goto not_there;
#endif
	if (strEQ(name, "FlashOverDowntoOutDown"))
#ifdef FlashOverDowntoOutDown
	    return FlashOverDowntoOutDown;
#else
	    goto not_there;
#endif
	if (strEQ(name, "FlashOverDowntoOverUp"))
#ifdef FlashOverDowntoOverUp
	    return FlashOverDowntoOverUp;
#else
	    goto not_there;
#endif
	if (strEQ(name, "FlashOverUptoIdle"))
#ifdef FlashOverUptoIdle
	    return FlashOverUptoIdle;
#else
	    goto not_there;
#endif
	if (strEQ(name, "FlashOverUptoOverDown"))
#ifdef FlashOverUptoOverDown
	    return FlashOverUptoOverDown;
#else
	    goto not_there;
#endif
	if (strEQ(name, "FlashTypeMenuButton"))
#ifdef FlashTypeMenuButton
	    return FlashTypeMenuButton;
#else
	    goto not_there;
#endif
	if (strEQ(name, "FlashTypePushButton"))
#ifdef FlashTypePushButton
	    return FlashTypePushButton;
#else
	    goto not_there;
#endif
	break;
    case 'G':
	break;
    case 'H':
	break;
    case 'I':
	break;
    case 'J':
	break;
    case 'K':
	break;
    case 'L':
	break;
    case 'M':
	break;
    case 'N':
	break;
    case 'O':
	break;
    case 'P':
	break;
    case 'Q':
	break;
    case 'R':
	if (strEQ(name, "RATE_11000"))
#ifdef RATE_11000
	    return RATE_11000;
#else
	    goto not_there;
#endif
	if (strEQ(name, "RATE_22000"))
#ifdef RATE_22000
	    return RATE_22000;
#else
	    goto not_there;
#endif
	if (strEQ(name, "RATE_44000"))
#ifdef RATE_44000
	    return RATE_44000;
#else
	    goto not_there;
#endif
	if (strEQ(name, "RATE_5500"))
#ifdef RATE_5500
	    return RATE_5500;
#else
	    goto not_there;
#endif
	break;
    case 'S':
	break;
    case 'T':
	break;
    case 'U':
	break;
    case 'V':
	break;
    case 'W':
	break;
    case 'X':
	break;
    case 'Y':
	break;
    case 'Z':
	break;
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}
MODULE = Flash  PACKAGE = Flash  PREFIX = SWF_

double
constant(name,arg)
	char *		name
	int		arg

void
SWF_doopenswf(name,xsize,ysize,framerate=20,r=1,g=1,b=1)
   char *name
   double xsize
   double ysize
   double framerate
   double r
   double g
   double b
   PROTOTYPE: $$$;$$$$
   CODE:
   {
      swf_openfile(name,xsize,ysize,framerate,r,g,b);
   }


void
SWF_docloseswf()
   CODE:
   {
      swf_closefile();
   }

void
SWF_label_frame(name)
   char* name
   PROTOTYPE: $
   CODE:
   {
      swf_labelframe(name);
   }

void
SWF_show_frame()
   CODE:
   {
      swf_showframe();
   }

void
SWF_set_frame(no)
   int no
   PROTOTYPE: $
   CODE:
   {
      swf_setframe(no);
   }

int
SWF_get_frame()
   CODE:
   {
      RETVAL = swf_getframe();
   }
   OUTPUT:
      RETVAL


void
SWF_add_colour(r=0,g=0,b=0,a=0)
   double r
   double g
   double b
   double a
   PROTOTYPE: ;$$$$
   CODE:
      swf_addcolor(r,g,b,a);

void
SWF_mul_colour(r=1,g=1,b=1,a=1)
   double r
   double g
   double b
   double a
   PROTOTYPE: ;$$$$
   CODE:
      swf_mulcolor(r,g,b,a);

void
SWF_place_object(id,depth)
   int id
   int depth
   PROTOTYPE: $$
   CODE:
      swf_placeobject(id,depth);

void
SWF_modify_object(id,how)
   int id
   int how
   PROTOTYPE: $$
   CODE:
      swf_modifyobject(id,how);

void
SWF_remove_object(depth)
   int depth
   PROTOTYPE: $
   CODE:
      swf_removeobject(depth);



void
SWF_line(id,x1,y1,x2,y2,width=1)
   int id
   double x1
   double y1
   double x2
   double y2
   double width
   PROTOTYPE: $$$$$;$
   CODE:
      swf_defineline(id,x1,y1,x2,y2,width);

void
SWF_rect(id,x1,y1,x2,y2,width=1)
   int id
   double x1
   double y1
   double x2
   double y2
   double width
   PROTOTYPE: $$$$$;$
   CODE:
      swf_definerect(id,x1,y1,x2,y2,width);

void
SWF_start_symbol(id)
   int id
   PROTOTYPE: $
   CODE:
      swf_startsymbol(id);

void
SWF_end_symbol()
   CODE:
      swf_endsymbol();


void
SWF_ortho2(xmin=-100,xmax=100,ymin=-100,ymax=100)
   double xmin
   double xmax
   double ymin
   double ymax
   PROTOTYPE: ;$$$$
   CODE:
      swf_ortho2(xmin,xmax,ymin,ymax);

void
SWF_start_doaction()
   CODE:
      swf_startdoaction();

void
SWF_end_doaction()
   CODE:
      swf_enddoaction();

void
SWF_action_play()
   CODE:
      swf_actionPlay();

void
SWF_action_stop()
   CODE:
      swf_actionStop();

void
SWF_start_button(id,menu)
   int id
   int menu
   PROTOTYPE: $$
   CODE:
      swf_startbutton(id,menu);

void
SWF_add_buttonrecord(state,id,depth)
   int state
   int id
   int depth
   PROTOTYPE: $$$
   CODE:
      swf_addbuttonrecord(state,id,depth);

void
SWF_on_condition(trans)
   int trans
   PROTOTYPE: $
   CODE:
      swf_oncondition(trans);

void
SWF_action_goto_frame(n)
   int n
   PROTOTYPE: $
   CODE:
      swf_actionGotoFrame(n);

void
SWF_action_get_URL(url,tar)
   char* url
   char* tar
   PROTOTYPE: $$
   CODE:
      swf_actionGetURL(url,tar);

void
SWF_action_next_frame()
   CODE:
      swf_actionNextFrame();

void
SWF_action_prev_frame()
   CODE:
      swf_actionPrevFrame();

void
SWF_action_toggle_quality()
   CODE:
      swf_actionToggleQuality();

void
SWF_action_stop_sounds()
   CODE:
      swf_actionStopSounds();

void
SWF_action_wait_for_frame(frame,skipcount)
   int frame
   int skipcount
   PROTOTYPE: $$
   CODE:
      swf_actionWaitForFrame(frame,skipcount);

void
SWF_action_set_target(tar)
   char* tar
   PROTOTYPE: $
   CODE:
      swf_actionSetTarget(tar);

void
SWF_action_goto_label(label)
   char* label
   PROTOTYPE: $
   CODE:
      swf_actionGoToLabel(label);

void
SWF_end_button()
   CODE:
      swf_endbutton();

void
SWF_push_matrix()
   CODE:
      swf_pushmatrix();

void
SWF_pop_matrix()
   CODE:
      swf_popmatrix();

void
SWF_viewport(xmin,xmax,ymin,ymax)
   double xmin
   double xmax
   double ymin
   double ymax
   PROTOTYPE: $$$$
   CODE:
      swf_viewport(xmin,xmax,ymin,ymax);

void
SWF_scale(x,y,z)
   double x
   double y
   double z
   PROTOTYPE: $$$
   CODE:
      swf_scale(x,y,z);

void
SWF_translate(x,y,z)
   double x
   double y
   double z
   PROTOTYPE: $$$
   CODE:
      swf_translate(x,y,z);

void
SWF_rotate(a,axis)
   double a
   char axis
   PROTOTYPE: $$
   CODE:
      swf_rotate(a,axis);

void
SWF_ortho(xmin=-100,xmax=100,ymin=-100,ymax=100,zmin=-100,zmax=100)
   double xmin
   double xmax
   double ymin
   double ymax
   double zmin
   double zmax
   PROTOTYPE: ;$$$$$$
   CODE:
      swf_ortho(xmin,xmax,ymin,ymax,zmin,zmax);


void
SWF_polarview(dist,az,in,tw)
   double dist
   double az
   double in
   double tw
   PROTOTYPE: $$$$
   CODE:
      swf_polarview(dist,az,in,tw);

void
SWF_lookat(vx,vy,vz,px,py,pz,tw)
   double vx
   double vy
   double vz
   double px
   double py
   double pz
   double tw
   PROTOTYPE: $$$$$$$
   CODE:
      swf_lookat(vx,vy,vz,px,py,pz,tw);

void
SWF_perspective(fovy,as,nr,fr)
   double fovy
   double as
   double nr
   double fr
   PROTOTYPE: $$$$
   CODE:
      swf_perspective(fovy,as,nr,fr);

void
SWF_pos_round(doit)
   int doit
   PROTOTYPE: $
   CODE:
      swf_posround(doit);

void
SWF_font_size(h=10)
   double h
   PROTOTYPE: ;$
   CODE:
      swf_fontsize(h);


void
SWF_font_slant(s)
   double s
   PROTOTYPE: $
   CODE:
      swf_fontslant(s);

void
SWF_font_tracking(t)
   double t
   PROTOTYPE: $
   CODE:
      swf_fonttracking(t);

void
SWF_font_line_width(t)
   double t
   PROTOTYPE: $
   CODE:
      swf_fontlinewidth(t);

void
SWF_define_font(id,name)
   int id
   char* name
   PROTOTYPE: $$
   CODE:
      swf_definefont(id,name);

void
SWF_set_font(id)
   int id
   PROTOTYPE: $
   CODE:
      swf_setfont(id);

int
SWF_text_width(s)
   char* s
   PROTOTYPE: $
   CODE:
      RETVAL = swf_textwidth(s);
   OUTPUT:
      RETVAL

void
SWF_get_font_info()
   PPCODE:
   {
      float ah,xh;
      swf_getfontinfo(&ah,&xh);
      EXTEND(sp,2);
      /* --- fix required */
      PUSHs(sv_2mortal(newSVnv(ah)));
      PUSHs(sv_2mortal(newSVnv(xh)));
   }

void
SWF_define_text(id,s,doc=0)
   int id
   char* s
   int doc
   PROTOTYPE: $$;$
   CODE:
      swf_definetext(id,s,doc);

void
SWF_define_bitmap(id,name)
   int id
   char* name
   PROTOTYPE: $$
   CODE:
      swf_definebitmap(id,name);

int
SWF_get_bitmap_info(id)
   int id
   PROTOTYPE: $
   PPCODE:
   {
      int x,y;
      swf_getbitmapinfo(id,&x,&y);
      EXTEND(sp,2);
      PUSHs(sv_2mortal(newSViv(x)));
      PUSHs(sv_2mortal(newSViv(y)));
   }


void
SWF_start_shape(id)
   int id
   PROTOTYPE: $
   CODE:
      swf_startshape(id);

void
SWF_shape_line_solid(r,g,b,a,w)
   double r
   double g
   double b
   double a
   double w
   PROTOTYPE: $$$$$
   CODE:
      swf_shapelinesolid(r,g,b,a,w);

void
SWF_shape_fill_off()
   CODE:
      swf_shapefilloff();

void
SWF_shape_fill_solid(r,g,b,a)
   double r
   double g
   double b
   double a
   PROTOTYPE: $$$$
   CODE:
      swf_shapefillsolid(r,g,b,a);

void
SWF_shape_fill_bitmap_clip(id)
   int id
   PROTOTYPE: $
   CODE:
      swf_shapefillbitmapclip(id);

void
SWF_shape_fill_bitmap_tile(id)
   int id
   PROTOTYPE: $
   CODE:
      swf_shapefillbitmaptile(id);

void
SWF_shape_moveto(x,y)
   double x
   double y
   PROTOTYPE: $$
   CODE:
      swf_shapemoveto(x,y);

void
SWF_shape_lineto(x,y)
   double x
   double y
   PROTOTYPE: $$
   CODE:
      swf_shapelineto(x,y);

void
SWF_shape_curveto(x1,y1,x2,y2)
   double x1
   double y1
   double x2
   double y2
   PROTOTYPE: $$$$
   CODE:
      swf_shapecurveto(x1,y1,x2,y2);

void
SWF_shape_curveto3(x1,y1,x2,y2,x3,y3)
   double x1
   double y1
   double x2
   double y2
   double x3
   double y3
   PROTOTYPE: $$$$$$
   CODE:
      swf_shapecurveto3(x1,y1,x2,y2,x3,y3);

void
SWF_shape_arc(x,y,r,a1,a2)
   double x
   double y
   double r
   double a1
   double a2
   PROTOTYPE: $$$$$
   CODE:
      swf_shapearc(x,y,r,a1,a2);

void
SWF_end_shape()
   CODE:
      swf_endshape();

void
SWF_sound_rate(rate=22000)
   int rate
   PROTOTYPE: $
   CODE:
      swf_soundrate(rate);

void
SWF_sound_compression(nbits=2)
   int nbits
   PROTOTYPE: $
   CODE:
      swf_soundcomp(nbits);

void
SWF_define_sound(id,soundf)
   int id
   char* soundf
   PROTOTYPE: $$
   CODE:
   {
      short* samples;
      AFfilehandle af = afOpenFile(soundf,"r",NULL);
      int format, bits, frames, channels;

      afGetSampleFormat(af,AF_DEFAULT_TRACK,&format,&bits);
      channels = afGetChannels(af,AF_DEFAULT_TRACK);
      frames = afGetFrameCount(af,AF_DEFAULT_TRACK);
#if defined(i386) || defined(alpha)
      afSetVirtualByteOrder(af,AF_DEFAULT_TRACK,AF_BYTEORDER_LITTLEENDIAN);
#else
      afSetVirtualByteOrder(af,AF_DEFAULT_TRACK,AF_BYTEORDER_BIGENDIAN);
#endif
      /* --- we could force it to the right ..
             but libaudiofile doesn't support it yet */
      /* afSetVirtualSampleFormat(af,AF_DEFAULT_TRACK,AF_SAMPFMT_TWOSCOMP,16); */

      if(bits==16&&channels==1) {
         short *buffer = (short *) malloc(frames * (bits/8) * channels);
         afReadFrames(af,AF_DEFAULT_TRACK,buffer,frames);
         swf_definesound(id,(short*)buffer,frames);
         /* ... can we free the *buffer again? who knows?! */
      } else {
         fprintf(stderr,"Soundfile \"%s\" is %d bits %d channels, instead 16 bits mono\n",
            soundf,bits,channels);
      }
      afCloseFile(af);
   }

void
SWF_define_button_sound(id,outid,overid,downid)
   int id
   int outid
   int overid
   int downid
   PROTOTYPE: $$$$
   CODE:
      swf_definebuttonsound(id,outid,overid,downid);

int
SWF_sound_stream(soundf)
   char* soundf
   PROTOTYPE: $
   CODE:
   {
      short* samples;
      int nsamples;
      RETVAL = swf_soundstream(samples,nsamples);
   }
   OUTPUT:
      RETVAL

void
SWF_start_sound(id)
   int id
   PROTOTYPE: $
   CODE:
      swf_startsound(id);

